> ## Documentation Index > Fetch the complete documentation index at: https://developer.rocket.chat/llms.txt > Use this file to discover all available pages before exploring further. # Update ABAC attribute definition >
Defense
- Updates an existing ABAC attribute definition. - Modifies the attribute identified by `_id`, allowing you to rename its key, change its list of allowed values, or both, subject to in-use and validation checks. - Requires the ABAC license, the `abac-management` and `manage-abac-admin-room-attributes` permissions, and the global setting `ABAC_Enabled` to be turned on. ### Changelog | Version | Description | | ------- | ----------- | | 8.0.0 | Added | | 8.5.0 | Added the `manage-abac-admin-room-attributes` granular permission requirement. | ## OpenAPI ````json PUT /api/v1/abac/attributes/:_id { "openapi": "3.0.0", "info": { "version": "1.0.0", "title": "Rooms" }, "servers": [ { "url": "https://apiexplorer.support.rocket.chat" } ], "tags": [ { "name": "Channels" }, { "name": "Directory" }, { "name": "Groups" }, { "name": "Rooms" }, { "name": "Teams" }, { "name": "Room Invites" }, { "name": "Subscriptions" }, { "name": "ABAC" } ], "paths": { "/api/v1/abac/attributes/:_id": { "parameters": [], "put": { "summary": "Update ABAC attribute definition", "tags": [ "ABAC" ], "responses": { "200": { "description": "OK", "content": { "application/json": { "schema": { "type": "object", "properties": { "success": { "type": "boolean" } } }, "examples": { "Success": { "value": { "success": true } } } } } }, "400": { "description": "Bad Request", "content": { "application/json": { "schema": { "type": "object", "properties": { "success": { "type": "boolean" }, "error": { "type": "string" } } }, "examples": { "ABAC disabled": { "value": { "success": false, "error": "error-abac-not-enabled" } }, "Attribute not found": { "value": { "success": false, "error": "error-attribute-not-found" } }, "Attribute in use (cannot rename key / cannot remove used values)": { "value": { "success": false, "error": "error-attribute-in-use" } }, "Invalid values (e.g. empty values)": { "value": { "success": false, "error": "error-invalid-attribute-values" } }, "Duplicate attribute key (renaming to an existing key)": { "value": { "success": false, "error": "error-duplicate-attribute-key" } } } } } }, "401": { "description": "Unauthorized", "content": { "application/json": { "schema": { "type": "object", "properties": { "success": { "type": "boolean" }, "error": { "type": "string" } } }, "examples": { "Unauthorized login attempt": { "value": { "success": false, "error": "error-unauthorized" } } } } } }, "403": { "description": "Forbidden", "content": { "application/json": { "schema": { "type": "object", "properties": { "success": { "type": "boolean" }, "error": { "type": "string" } } }, "examples": { "Missing required ABAC permissions": { "value": { "success": false, "error": "error-not-authorized" } } } } } } }, "operationId": "put-abac-attributes-:_id", "description": "
\"Defense\"
\n\n- Updates an existing ABAC attribute definition.\n- Modifies the attribute identified by `_id`, allowing you to rename its key, change its list of allowed values, or both, subject to in-use and validation checks.\n- Requires the ABAC license, the `abac-management` and `manage-abac-admin-room-attributes` permissions, and the global setting `ABAC_Enabled` to be turned on.\n\n### Changelog\n| Version | Description |\n| ------- | ----------- |\n| 8.0.0 | Added |\n| 8.5.0 | Added the `manage-abac-admin-room-attributes` granular permission requirement. |", "parameters": [ { "$ref": "#/components/parameters/Auth-Token" }, { "$ref": "#/components/parameters/UserId" } ], "requestBody": { "content": { "application/json": { "schema": { "type": "object", "x-examples": { "Example 1": { "key": "my_department", "values": [ "eng", "sales" ] } }, "required": [ "key", "values" ], "properties": { "key": { "type": "string", "example": "my_department" }, "values": { "type": "array", "items": { "type": "string" }, "example": [ "eng", "sales" ] } } } } } } } } }, "components": { "parameters": { "Auth-Token": { "name": "X-Auth-Token", "in": "header", "description": "The `authToken` of the authenticated user.", "required": true, "schema": { "type": "string" }, "example": "RScctEHSmLGZGywfIhWyRpyofhKOiMoUIpimhvheU3f" }, "UserId": { "name": "X-User-Id", "in": "header", "description": "The `userId` of the authenticated user.", "required": true, "schema": { "type": "string" }, "example": "rbAXPnMktTFbNpwtJ" } } } } ````